#ifndef GPS_H
#define GPS_H

#include <QObject>

#include <qmobilityglobal.h>

#include "location.h"

QTM_BEGIN_NAMESPACE
class QGeoPositionInfoSource;
class QGeoPositionInfo;
QTM_END_NAMESPACE
	
QTM_USE_NAMESPACE

class Gps : public QObject
{
Q_OBJECT
public:
    explicit Gps(QObject *parent = 0);
    
    void getPosition();
    
    FinnishCoordinates currentPosition();

signals:
    
    void positionAvailable();
    
    void positionError();
public slots:
    
    void positionUpdated(const QGeoPositionInfo & update);
    
    
    
private:
    QGeoPositionInfoSource *mGps;

};

#endif // GPS_H
